unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Gauges,
  VBScript_RegExp_55_TLB, ComCtrls, ImgList;

//-----------------------------------------------------------------------------
type
    TPageInfo = record
        URL: string;
        Host: string;
        Page: string;
        Status: string;
        HttpCode: integer;
        ContentType: string;
        Charset: string;
        Title: string;
        Description: string;
    end;

type
  TMainForm = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Splitter1: TSplitter;
    MemoResult: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    EditFormat1: TEdit;
    EditFormat2: TEdit;
    EditFormat3: TEdit;
    EditFormat4: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    ImageList1: TImageList;
    Panel1: TPanel;
    BtnBuild: TBitBtn;
    Label17: TLabel;
    RbtnFormat1: TRadioButton;
    RbtnFormat2: TRadioButton;
    RbtnFormat3: TRadioButton;
    RbtnFormat4: TRadioButton;
    ChkNotask: TCheckBox;
    BtnVersion: TBitBtn;
    BtnClose: TBitBtn;
    ChkNotFromClipboard: TCheckBox;
    Label18: TLabel;
    LblProgress: TLabel;
    Label10: TLabel;
    EditDateFormat: TEdit;
    ChkNotDate: TCheckBox;
    EditLeftPar: TEdit;
    EditRightPar: TEdit;
    Panel2: TPanel;
    Panel3: TPanel;
    MemoSource: TMemo;
    BtnSelAll: TBitBtn;
    BtnClear: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnVersionClick(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnBuildClick(Sender: TObject);
    procedure EditFormat1Change(Sender: TObject);
    procedure BtnSelAllClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
  private
    FRegBuf: TRegExp;
    FStrBuf: TStringList;
    function GetPageInformation(const URL: string): TPageInfo;
  private
    FStream: TStringStream;
    function CallbackDownload(const Buf; const BufLen: integer): Boolean;
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    StrUtils, Jconvert, Info, Http, ClipBrd;

//-----------------------------------------------------------------------------
//  2005.09.03  RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);
    FRegBuf := TRegExp.Create(nil);
    FStrBuf := TStringList.Create();
    PageControl.ActivePageIndex := 0;
    LoadPropertyFromFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
end;

//-----------------------------------------------------------------------------
//  2005.09.03  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    SavePropertyToFile(ChangeFileExt(ParamStr(0), '.ini'), Self);
    FRegBuf.Free;
    FStrBuf.Free;
end;

//-----------------------------------------------------------------------------
//  2005.09.06  Tu}b`1ڂ߂
function GetSubMatchItem0(RegBuf: TRegExp; const Data, Pattern: string): string;
var
    Matches, SubMatches: OleVariant;
begin
    Result := '';
    RegBuf.Pattern := Pattern;
    RegBuf.Global := false;            //  ŏ
    RegBuf.IgnoreCase := true;         //  啶E
    Matches := RegBuf.Execute(Data);   //  
    if (Matches.Count > 0) then
    begin
        SubMatches := Matches.Item[0].SubMatches;
        if (SubMatches.Count > 0) then
        begin
            Result := SubMatches.Item[0];
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  2005.09.06  R[hϊ
procedure ConvertCoding(var Data: string; const Charset: string);
begin
    //  Shift_JIS
    if (AnsiContainsText(Charset, 'Shift_JIS')) then
    begin
        //  ̂܂
    end

    //  xsjis
    else if (AnsiContainsText(Charset, 'xsjis')) then
    begin
        //  ̂܂
    end

    //  UTF-8
    else if (AnsiContainsText(Charset, 'UTF-8')) then
    begin
        Data := Utf8ToAnsi(Data);
    end

    //  EUC̏ꍇ
    else if (AnsiContainsText(Charset, 'euc')) then
    begin
        Data := euc2sjis(Data);
    end

    //  s̏ꍇ
    else
    begin
        Data := ConvertJCode(Data, SJIS_OUT);
    end;
end;

//-----------------------------------------------------------------------------
//  2005.09.08  _E[hf[^󂯎֐
function TMainForm.CallbackDownload(const Buf; const BufLen: integer): Boolean;
var
    CancelCondition: Boolean;
begin
    FStream.Write(Buf, BufLen);

    //  "<body" ŃLZ(ȏ͕sv)
    CancelCondition := AnsiContainsText(FStream.DataString, '<body'); 
    Result := not CancelCondition;
end;

//-----------------------------------------------------------------------------
//  2005.09.06  Pagȅ擾
function TMainForm.GetPageInformation(const URL: string): TPageInfo;
var
    host, page, Command: string;
    Data, Pattern: string;
    Counter: integer;
begin
    //  
    FillChar(Result, SizeOf(Result), #0);

    Result.URL := URL;

    //  URL
    if (not SplitUrl(Result.URL, host, page)) then Exit;

    FStream := nil;
    try
        try
            //  [v悯
            Counter := 0;

            while (Counter < 10) do
            begin
                Inc(Counter);

                Result.Host := host;
                Result.Page := page;

                //  R}h쐬
                Command := Format(
                    'GET %s HTTP/1.0'#13#10
                  + 'HOST: %s:80'#13#10
                  + 'User-Agent: Mozilla/4.0 (compatible; MSIE 5.5; Windows NT 5.0)'
                  + #13#10#13#10, [page, host]);

                //  Xg[쐬
                FStream := TStringStream.Create('');

                //  _E[h
                if (not DownloadViaHTTP(host, Command, CallbackDownload)) then break;

                //  wb_̃Xg[f[^𕶎
                Data := FStream.DataString;

                //  pς
                FreeAndNil(FStream);

                //  Xe[^Xo
                Pattern := '(^HTTP/[0-9]\.[0-9][\s]+[0-9]+[\s]+[^\s]*)';
                Result.Status := GetSubMatchItem0(FRegBuf, Data, Pattern);

                //  Xe[^XR[ho
                Pattern := '^HTTP/[0-9]\.[0-9][\s]+([0-9]+)[\s]+[^\s]*';
                Result.HttpCode := StrToIntDef(GetSubMatchItem0(FRegBuf, Result.Status, Pattern), -1);

                //  Ȃ񂶂Ⴑ႟
                if (Result.HttpCode < 0) then break;

                //  ړH
                if ((Result.HttpCode = 301) or (Result.HttpCode = 302)) then
                begin
                    //  Location o
                    Pattern := 'Location:[\s]*([^\s]*)';
                    page := GetSubMatchItem0(FRegBuf, Data, Pattern);

                    //  http n܂ĂH
                    if (AnsiStartsText('http', page)) then
                    begin
                        //  URLXV
                        Result.URL := page;

                        //  ߂URL
                        if (not SplitUrl(Result.URL, host, page)) then Exit;
                    end;

                    //  蒼
                    continue;
                end;

                //  200ȊO͂ǂĂ̂
                if (Result.HttpCode <> 200) then break;

                //  Content-Typeo
                Pattern := 'Content-Type:[\s]*([^;\s]*)';
                Result.ContentType := GetSubMatchItem0(FRegBuf, Data, Pattern);

                //  Content-Type META^O
                if (Result.ContentType = '') then
                begin
                    Pattern := 'http-equiv=["]?content-type"[\s]+content=["]?([^;"\s]*)';
                    Result.ContentType := Trim(GetSubMatchItem0(FRegBuf, Data, Pattern));
                end;

                //  charseto(T[o[X|XMETA^Oɔ)
                Pattern := ';[\s]*charset[\s]*=[\s]*([^\s">]*)';
                Result.Charset := Trim(GetSubMatchItem0(FRegBuf, Data, Pattern));

                //  R[hϊ
                ConvertCoding(Data, Result.Charset);

//DEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUG
//FStrBuf.Text := Data;
//FStrBuf.SaveToFile(ChangeFileExt(Application.ExeName, host + '.txt'));
//DEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUGDEBUG

                //  ^Cg^O̔
                Pattern := '<title[^>]*>([^<]*)</title>';
                Result.Title := GetSubMatchItem0(FRegBuf, Data, Pattern);

                //  ^CgȂȂsĂ邩Ƃ݂ȂėƂ
                if (Result.Title = '') then
                begin
                    Data := StringReplace(Data, #13, '', [rfReplaceAll]);
                    Data := StringReplace(Data, #10, '', [rfReplaceAll]);

                    //  ߂ă^Cg^O̔
                    Pattern := '<title[^>]*>([^<]*)</title>';
                    Result.Title := GetSubMatchItem0(FRegBuf, Data, Pattern);
                end;

                //  ̔-Xebv1
                Pattern := '<meta[\s]*name[\s]*=[\s]*"?description"?[\s]*([^>]*)>';
                Result.Description := Trim(GetSubMatchItem0(FRegBuf, Data, Pattern));

                //  ̔-Xebv2
                Pattern := 'content[\s]*="?([^">]*)"?';
                Result.Description := GetSubMatchItem0(FRegBuf, Result.Description, Pattern);

                //  ܂
                break;
            end;
        finally
            FreeAndNil(FStream);
        end;
    except
        //
    end;
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.BtnVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  vOI
procedure TMainForm.BtnCloseClick(Sender: TObject);
begin
    Self.Close();
end;

//-----------------------------------------------------------------------------
//  ύX
procedure TMainForm.EditFormat1Change(Sender: TObject);
begin
    if (Sender = EditFormat1) then RbtnFormat1.Hint := EditFormat1.Text
    else if (Sender = EditFormat2) then RbtnFormat2.Hint := EditFormat2.Text
    else if (Sender = EditFormat3) then RbtnFormat3.Hint := EditFormat3.Text
    else if (Sender = EditFormat4) then RbtnFormat4.Hint := EditFormat4.Text;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.BtnBuildClick(Sender: TObject);
var
    i: integer;
    PageInfo: TPageInfo;
    Template: String;
    Temp: String;
begin
    if (not ChkNotask.Checked) then
    begin
        if (
            AppMessageBox('()Nbv{[h URL 擾āAϊ'#13#10
                    + 'Nbv{[h㏑܂B'#13#10#13#10
                    + '̂ƂAC^[lbgɐڑ܂B'#13#10
                    + '肠܂񂩁H',
                    MB_YESNO or MB_ICONQUESTION)
            = ID_NO) then Exit;
    end;

    //  Nbv{[hɂȂ炩̕Ăꍇ
    if (not ChkNotFromClipboard.Checked) and (ClipBoard.AsText <> '') then
    begin
        MemoSource.Clear();
        MemoSource.PasteFromClipboard();
    end;

    //  tH[}bg擾
         if (RbtnFormat2.Checked) then Template := RbtnFormat2.Hint
    else if (RbtnFormat3.Checked) then Template := RbtnFormat3.Hint
    else if (RbtnFormat4.Checked) then Template := RbtnFormat4.Hint
    else Template := RbtnFormat1.Hint;

    //  Ԃɕϊ
    MemoResult.Clear();

    LblProgress.Caption := Format('%d/%d', [MemoResult.Lines.Count, MemoSource.Lines.Count]);
    LblProgress.Refresh();
    for i := 0 to MemoSource.Lines.Count - 1 do
    begin
        PageInfo := GetPageInformation(MemoSource.Lines.Strings[i]);
        if (PageInfo.Title = '') then PageInfo.Title := PageInfo.URL;

        Temp := Template;
        Temp := StringReplace(Temp, '#URL#', PageInfo.URL, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#HOST#', PageInfo.Host, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#PAGE#', PageInfo.Page, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#STATUS#', PageInfo.Status, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#CONTENTTYPE#', PageInfo.ContentType, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#CHARSET#', PageInfo.Charset, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#TITLE#', PageInfo.Title, [rfReplaceAll, rfIgnoreCase]);
        Temp := StringReplace(Temp, '#DESCRIPTION#', PageInfo.Description, [rfReplaceAll, rfIgnoreCase]);

        if (not ChkNotDate.Checked) then
        begin
            Temp := Temp
                  + EditLeftPar.Text
                  + FormatDateTime(EditDateFormat.Text, Now())
                  + EditRightPar.Text;
        end;

        MemoResult.Lines.Add(Temp);
        LblProgress.Caption := Format('%d/%d', [MemoResult.Lines.Count, MemoSource.Lines.Count]);
        LblProgress.Refresh();
    end;
    MemoResult.SelectAll();
    LblProgress.Caption := '-/-';

    MemoResult.CopyToClipboard();
end;

//-----------------------------------------------------------------------------
//  URLSI
procedure TMainForm.BtnSelAllClick(Sender: TObject);
begin
    MemoSource.SelectAll();
    MemoSource.SetFocus();
end;

//-----------------------------------------------------------------------------
//  URLSNA
procedure TMainForm.BtnClearClick(Sender: TObject);
begin
    MemoSource.Clear();
end;

end.

